import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        String str1 = br.readLine();
        String str2 = br.readLine();
        if(str1.length()<str2.length()){
            String c = str1;
            str1 = str2;
            str2 = c;
        }
        String[] str3 = new String[str2.length()];
        for (int i = 0; i < str2.length(); i++) {
            str3[i] = "";
            for (int j = 0; j < str1.length(); j++) {
                str3[i] += Math.min(str1.charAt(j)-'0',str2.charAt(i)-'0');
            }
            for (int j = 0; j < str2.length()-1-i; j++) {
                str3[i]+="0";
            }
        }
        String ret = "";
        for (int i = str3.length-1; i >= 0; i--) {
            ret = summ(ret,str3[i]);
        }
        System.out.println(summ(str1,str2) + " " + ret);
        out.close();
    }
    static String summ(String a,String b){
        if(a.length()<b.length()){
            String c = a;
            a = b;
            b = c;
        }
        String ret = a.substring(0,a.length()-b.length());
        a = a.substring(a.length()-b.length(),a.length());
        for (int i = 0; i < b.length(); i++) {
            ret+=Math.max(a.charAt(i)-'0',b.charAt(i)-'0');
        }
        return ret;
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}