import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        double a = nextInt();
        double b = nextInt();
        double x1 = 0;
        double y1 = 1;
        double x2 = 1;
        double y2 = 0;
        StringBuilder sb = new StringBuilder("R");
        while (a/b!=(x1+x2)/(y1+y2)){
            if(a/b>(x1+x2)/(y1+y2)){
                sb.append("R");
                x1 = x1+x2;
                y1 = y1+y2;
            } else if (a/b<(x1+x2)/(y1+y2)) {
                sb.append("L");
                x2 = x1+x2;
                y2 = y1+y2;
            }
        }
        System.out.println(sb);
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}