import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int m = nextInt();
        int k = nextInt();
        int[][] arr = new int[2][m];
        int[] orr = new int[n+1];
        for (int i = 0; i < m; i++) {
            arr[0][i] = nextInt();
            arr[1][i] = nextInt();
        }
        for (int i = 0; i < k; i++) {
            orr[nextInt()] = nextInt()+1;
        }
        for (int i = 0; i < m; i++) {
            if (orr[arr[0][i]] > orr[arr[1][i]]) {
                orr[arr[1][i]] = orr[arr[0][i]]-1;
            }
            else if(orr[arr[0][i]] < orr[arr[1][i]]){
                orr[arr[0][i]] = orr[arr[1][i]]-1;
            }
        }
        StringBuilder sb = new StringBuilder();
        int sum = 0;
        for (int i = 1; i < n+1; i++) {
            if(orr[i]>0){
                sum++;
                sb.append(i + " ");
            }
        }
        if(sum > 0) {
            System.out.println(sum);
        }
        System.out.println(sb);
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}