import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int m = nextInt();
        int k = nextInt();
        int[][] arr = new int[n+1][n+1];
        int[] ind = new int[n+1];
        for (int i = 0; i < m; i++) {
            int x = nextInt();
            int y = nextInt();
            arr[x][ind[x]] = y;
            arr[y][ind[y]] = x;
            ind[x]++;
            ind[y]++;
        }
        int[] orr = new int[n+1];
        int max = Integer.MIN_VALUE;
        for (int i = 0; i < k; i++) {
            int x = nextInt();
            int y = nextInt();
            orr[x] = y+1;
            max = Math.max(max,y+1);
        }
        for (int i = 0; i < max; i++) {
            for (int j = 0; j < n; j++) {
                if(orr[j] == max){
                    for (int l = 0; l < ind[j]; l++) {
                        orr[arr[j][l]] = max-1;
                    }
                }
            }
            max--;
        }
        StringBuilder sb = new StringBuilder();
        int sum = 0;
        for (int i = 1; i < n+1; i++) {
            if(orr[i]>0){
                sum++;
                sb.append(i + " ");
            }
        }
        System.out.println(sum);
        System.out.println(sb);
        out.close();
    }
    static int[][] sort(int[][] a,int[] n){
        if(a[0].length == 1){
            return a;
        }
        else {
            int[][] b = new int[2][a[0].length/2];
            int[][] c = new int[2][(int) ((double)a[0].length/2+0.9)];
            for (int i = 0; i < b[0].length; i++) {
                int x = a[0][i];
                int y = a[1][i];
                b[0][i] = x;
                b[1][i] = y;
            }
            for (int i = 0; i < c[0].length; i++) {
                int x = a[0][b[0].length+i];
                int y = a[1][b[0].length+i];
                c[0][i] = x;
                c[1][i] = y;
            }
            b = sort(b,n);
            c = sort(c,n);
            return sliv(b,c,n);
        }
    }
    static int[][] sliv(int[][] a,int[][] b, int[] n){
        int ax = 0;
        int bx = 0;
        int[][] c = new int[2][a[0].length+b[0].length];
        while (ax < a[0].length || bx < b[0].length){
            if(ax == a[0].length){
                c[0][ax+bx] = b[0][bx];
                c[1][ax+bx] = b[1][bx];
                bx++;
            } else if (bx == b[0].length) {
                c[0][ax+bx] = a[0][ax];
                c[1][ax+bx] = a[1][ax];
                ax++;
            }
            else if(Math.max(n[a[0][ax]],n[a[1][ax]]) > Math.max(n[b[0][bx]],n[b[1][bx]])){
                c[0][ax+bx] = a[0][ax];
                c[1][ax+bx] = a[1][ax];
                ax++;
            }
            else {
                c[0][ax+bx] = b[0][bx];
                c[1][ax+bx] = b[1][bx];
                bx++;
            }
        }
        return c;
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}